package dev.shadowsoffire.apotheosis.village.wanderer;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.util.Function7;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.village.wanderer.JsonTrade;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import dev.shadowsoffire.placebo.json.ItemAdapter;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.common.BasicItemListing;

public class WandererTrade extends BasicItemListing implements JsonTrade {
  public static Codec<dev.shadowsoffire.apotheosis.village.wanderer.WandererTrade> CODEC;
  
  protected final boolean rare;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)ItemAdapter.CODEC.fieldOf("input_1").forGetter(()), (App)PlaceboCodecs.nullableField(ItemAdapter.CODEC, "input_2", ItemStack.f_41583_).forGetter(()), (App)ItemAdapter.CODEC.fieldOf("output").forGetter(()), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "max_trades", Integer.valueOf(1)).forGetter(()), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "xp", Integer.valueOf(0)).forGetter(()), (App)PlaceboCodecs.nullableField((Codec)Codec.FLOAT, "price_mult", Float.valueOf(1.0F)).forGetter(()), (App)PlaceboCodecs.nullableField((Codec)Codec.BOOL, "rare", Boolean.valueOf(false)).forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.village.wanderer.WandererTrade::new));
  }
  
  public WandererTrade(ItemStack price, ItemStack price2, ItemStack forSale, int maxTrades, int xp, float priceMult, boolean rare) {
    super(price, price2, forSale, maxTrades, xp, priceMult);
    this.rare = rare;
  }
  
  public boolean isRare() {
    return this.rare;
  }
  
  public Codec<? extends JsonTrade> getCodec() {
    return (Codec)CODEC;
  }
}
